// WL_AGENT.C

#include "WL_DEF.H"
#pragma hdrstop


/*
=============================================================================

						 LOCAL CONSTANTS

=============================================================================
*/

#define MAXMOUSETURN	10


#define MOVESCALE		150l
#define BACKMOVESCALE	100l
#define ANGLESCALE		20

/*
=============================================================================

						 GLOBAL VARIABLES

=============================================================================
*/



//
// player state info
//
boolean		running;
long		thrustspeed;

unsigned	plux,pluy;			// player coordinates scaled to unsigned

int			anglefrac;
int			gotgatgun;	// JR

objtype		*LastAttacker;

/*
=============================================================================

						 LOCAL VARIABLES

=============================================================================
*/


void	T_Player (objtype *ob);
void	T_Attack (objtype *ob);

statetype s_player = {false,0,0,T_Player,NULL,NULL};
statetype s_attack = {false,0,0,T_Attack,NULL,NULL};


long	playerxmove,playerymove;

struct atkinf
{
	char	tics,attack,frame;		// attack is 1 for gun, 2 for knife
//} attackinfo[4][14] =
} attackinfo[4][14] =

{
{ {6,0,1},{6,2,2},{6,3,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
//{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },			//original
//{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },                 //original
{ {6,0,1},{6,1,2},{6,3,3},{6,-1,4} },
{ {6,0,1},{6,1,2},{6,0,3},{6,-1,4} },
//
//{ {6,0,1},{6,1,2},{6,4,3},{6,-1,4} },
//
};


int	strafeangle[9] = {0,90,180,270,45,135,225,315,0};

void DrawWeapon (void);
void GiveWeapon (int weapon);
void	GiveAmmo (int ammo, char s_o_b);
void	GiveArmor (int points);

//===========================================================================

//----------

void Attack (void);
void Use (void);
void Search (objtype *ob);
void SelectWeapon (void);
void SelectItem (void);

//----------

boolean TryMove (objtype *ob);
void T_Player (objtype *ob);

void ClipMove (objtype *ob, long xmove, long ymove);

/*
=============================================================================

						CONTROL STUFF

=============================================================================
*/

/*
======================
=
= CheckWeaponChange
=
= Keys 1-6 change weapons
=
======================
*/

void CheckWeaponChange (void)
{
	int	i,buttons;

	if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)		// must use knife with no ammo
	{
		gamestate.weapon = wp_knife;
		return;
	}
	if (gamestate.chosenweapon == wp_machinegun && gamestate.bestweapon < wp_machinegun && !gamestate.shells)
	{
		gamestate.chosenweapon = gamestate.weapon = wp_knife;
	}


/*	for (i=wp_knife ; i<=gamestate.bestweapon ; i++)
		if (buttonstate[bt_readyknife+i-wp_knife])
		{
			gamestate.weapon = gamestate.chosenweapon = i;
			DrawWeapon ();
			return;
		}
*/


	if (Keyboard[sc_1] && gamestate.bestweapon >= wp_knife)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_knife;
	}
	if (Keyboard[sc_2] && gamestate.bestweapon >= wp_pistol)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_pistol;
	}
	if (Keyboard[sc_3] && gamestate.bestweapon >= wp_machinegun)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
	}
	if (Keyboard[sc_4] && gamestate.bestweapon >= wp_chaingun)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
	}
	if (Keyboard[sc_5] && gamestate.bestweapon >= wp_newgun)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_newgun;
	}
	if (Keyboard[sc_6] && gamestate.bestweapon >= wp_pgun)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_pgun;
	}
	if (Keyboard[sc_7] && gamestate.bestweapon >= wp_blastgun)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_blastgun;
	}

	//// see if they pressed 'x'
	if (Keyboard[sc_X])
	{
		if (gamestate.crosshair == 0)
		{
			gamestate.crosshair = 1;
		}
		else
		{
			gamestate.crosshair = 0;
		}
	}
	////
	if (Keyboard[sc_F])
	{
		if (gamestate.flash == 0)
		{
			gamestate.flash = 1;
		}
		else
		{
			gamestate.flash = 0;
		}
	}
	////

	if (Keyboard[sc_N]  && Keyboard[sc_S])
	{
		//US_PrintCentered ("Good job, you found the extra episode.\n");
		gamestate.extraep = 1;
		ExtraEp ();
	}
	////



	//make ammo change with shells/bullets
	if (gamestate.chosenweapon == wp_pistol)
	{
		gamestate.ammo = gamestate.shells;
	}
	if (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun)
	{
		gamestate.ammo = gamestate.bullets;
	}
	if (gamestate.chosenweapon == wp_chaingun)
	{
		gamestate.ammo = gamestate.rockets;
	}

	// if in the Rocket Arena, always switch to missiles!
	if (gamestate.episode == 3 && mapon == 0 && gamestate.rockets)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
		gamestate.ammo = gamestate.rockets;
	}

	/*// hot-gun
	if (Keyboard[sc_H])
	{
		gamestate.hotgun = gamestate.chosenweapon;
	}

	if (Keyboard[sc_O])
	{
		if (gamestate.hotfeature == 0)
		{
			gamestate.hotfeature = 1;
		}
		else
		{
			gamestate.hotfeature = 0;
		}
	}


	/////   keep hotammo up with ammo count
	if (gamestate.hotfeature)
	{
		if (gamestate.hotgun == wp_pistol)
			gamestate.hotammo = gamestate.shells;
		if (gamestate.hotgun == wp_machinegun || gamestate.hotgun == wp_newgun)
			gamestate.hotammo = gamestate.bullets;
		if (gamestate.hotgun == wp_chaingun)
			gamestate.hotammo = gamestate.rockets;
	}

	////////  check for hotammo
	if (gamestate.hotfeature && gamestate.hotammo)
	{
		gamestate.chosenweapon = gamestate.weapon = wp_newgun;
		gamestate.ammo = gamestate.hotammo;
	}
	//////*/

	DrawAmmo ();
}


/*
=======================
=
= ControlMovement
=
= Takes controlx,controly, and buttonstate[bt_strafe]
=
= Changes the player's angle and position
=
= There is an angle hack because when going 70 fps, the roundoff becomes
= significant
=
=======================
*/

void ControlMovement (objtype *ob)
{
	long	oldx,oldy;
	int		angle,maxxmove;
	int		angleunits;
	long	speed;

	thrustspeed = 0;

	oldx = player->x;
	oldy = player->y;

//
// side to side move
//
	if (buttonstate[bt_strafe])
	{
	//
	// strafing
	//
	//
		if (controlx > 0)
		{
			angle = ob->angle - ANGLES/4;
			if (angle < 0)
				angle += ANGLES;
			Thrust (angle,controlx*MOVESCALE);	// move to left
		}
		else if (controlx < 0)
		{
			angle = ob->angle + ANGLES/4;
			if (angle >= ANGLES)
				angle -= ANGLES;
			Thrust (angle,-controlx*MOVESCALE);	// move to right
		}
	}
	else
	{
	//
	// not strafing
	//
		anglefrac += controlx;
		angleunits = anglefrac/ANGLESCALE;
		anglefrac -= angleunits*ANGLESCALE;
		ob->angle -= angleunits;

		if (ob->angle >= ANGLES)
			ob->angle -= ANGLES;
		if (ob->angle < 0)
			ob->angle += ANGLES;

	}

//
// forward/backwards move
//
	if (controly < 0)
	{
		Thrust (ob->angle,-controly*MOVESCALE);	// move forwards
	}
	else if (controly > 0)
	{
		angle = ob->angle + ANGLES/2;
		if (angle >= ANGLES)
			angle -= ANGLES;
		Thrust (angle,controly*BACKMOVESCALE);		// move backwards
	}

	if (gamestate.victoryflag)		// watching the BJ actor
		return;

//
// calculate total move
//
	playerxmove = player->x - oldx;
	playerymove = player->y - oldy;
}

/*
=============================================================================

					STATUS WINDOW STUFF

=============================================================================
*/


/*
==================
=
= StatusDrawPic
=
==================
*/

void StatusDrawPic (unsigned x, unsigned y, unsigned picnum)
{
	unsigned	temp;

	temp = bufferofs;
	bufferofs = 0;

	bufferofs = PAGE1START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE2START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);
	bufferofs = PAGE3START+(200-STATUSLINES)*SCREENWIDTH;
	LatchDrawPic (x,y,picnum);

	bufferofs = temp;
}


/*
==================
=
= DrawFace
=
==================
*/

void DrawFace (void)
{
	if (gamestate.health)
	{
		#ifdef SPEAR
		if (godmode)
			StatusDrawPic (17,4,GODMODEFACE1PIC+gamestate.faceframe);
		else
		#endif
		StatusDrawPic (17,4,FACE1APIC+3*((100-gamestate.health)/16)+gamestate.faceframe);
	}
	else
	{
#ifndef SPEAR
	 if (LastAttacker->obclass == needleobj)
	   StatusDrawPic (17,4,MUTANTBJPIC);
	 else
#endif
	   StatusDrawPic (17,4,FACE8APIC);
	}

/*	if (gamestate.episode == 1 && mapon == 8 && ( US_RndT () % 75 == 1 ) )
		SD_PlaySound (MEINGOTTSND);
	else if ( US_RndT() % 110 == 1 && mapon != 8)
		SD_PlaySound (SPIONSND);*/




}


/*
===============
=
= UpdateFace
=
= Calls draw face if time to change
=
===============
*/

#define FACETICS	70

int	facecount;

void	UpdateFace (void)
{

	if (SD_SoundPlaying() == GETGATLINGSND)
	  return;

	facecount += tics;
	if (facecount > US_RndT())
	{
		gamestate.faceframe = (US_RndT()>>6);
		if (gamestate.faceframe==3)
			gamestate.faceframe = 1;

		facecount = 0;
		DrawFace ();
	}
}



/*
===============
=
= LatchNumber
=
= right justifies and pads with blanks
=
===============
*/

void	LatchNumber (int x, int y, int width, long number)
{
	unsigned	length,c;
	char	str[20];

	ltoa (number,str,10);

	length = strlen (str);

	while (length<width)
	{
		StatusDrawPic (x,y,N_BLANKPIC);
		x++;
		width--;
	}

	c= length <= width ? 0 : length-width;

	while (c<length)
	{
		StatusDrawPic (x,y,str[c]-'0'+ N_0PIC);
		x++;
		c++;
	}
}


/*
===============
=
= DrawHealth
=
===============
*/

void	DrawHealth (void)
{
	LatchNumber (21,16,3,gamestate.health);
}


/*
===============
=
= TakeDamage
=
===============
*/

void	TakeDamage (int points,objtype *attacker)
{
	LastAttacker = attacker;

	if (gamestate.victoryflag)
		return;
	if (gamestate.difficulty==gd_baby)
	  points>>=2;

	if (!godmode)
	{
		if (gamestate.armor)
		{
			if ((gamestate.health -= points / 3) >= 0)
			{
				gamestate.health -= ((int)points / 3);
				if (gamestate.health > 115)
					gamestate.health = 115;
			}
			gamestate.armor -= points / 2 + 2;
		}
		else
		{
			gamestate.health -= points;
		}
	}

	if (gamestate.armor <= 0)
		gamestate.armor = 0;

	DrawWeapon ();


	if (gamestate.health<=0)
	{
		gamestate.health = 0;
		playstate = ex_died;
		killerobj = attacker;
	}

	StartDamageFlash (points);

	gotgatgun=0;

	DrawHealth ();
	DrawFace ();

	//
	// MAKE BJ'S EYES BUG IF MAJOR DAMAGE!
	//
	#ifdef SPEAR
	if (points > 30 && gamestate.health!=0 && !godmode)
	{
		StatusDrawPic (17,4,BJOUCHPIC);
		facecount = 0;
	}
	#endif

}


/*
===============
=
= HealSelf
=
===============
*/

void	HealSelf (int points)
{
	gamestate.health += points;
	if (gamestate.health>115)
		gamestate.health = 115;

	DrawHealth ();
	gotgatgun = 0;	// JR
	DrawFace ();
}


//===========================================================================


/*
===============
=
= DrawLevel
=
===============
*/

void	DrawLevel (void)
{
#ifdef SPEAR
	if (gamestate.mapon == 20)
		LatchNumber (2,16,2,18);
	else
#endif
	LatchNumber (2,16,2,gamestate.mapon+1);
}

//===========================================================================


/*
===============
=
= DrawLives
=
===============
*/

void	DrawLives (void)
{
	LatchNumber (14,16,1,gamestate.lives);
}


/*
===============
=
= GiveExtraMan
=
===============
*/

void	GiveExtraMan (void)
{
	if (gamestate.lives<9)
		gamestate.lives++;
	DrawLives ();
	SD_PlaySound (BONUS1UPSND);
}

//===========================================================================

/*
===============
=
= DrawScore
=
===============
*/

void	DrawScore (void)
{
	LatchNumber (6,16,6,gamestate.score);
}

/*
===============
=
= GivePoints
=
===============
*/

void	GivePoints (long points)
{
	gamestate.score += points;
	while (gamestate.score >= gamestate.nextextra)
	{
		gamestate.nextextra += EXTRAPOINTS;
		GiveExtraMan ();
	}
	DrawScore ();
}

//===========================================================================

/*
==================
=
= DrawWeapon
=
==================
*/

void DrawWeapon (void)
{
	/*if (gamestate.weapon != wp_newgun)
		StatusDrawPic (32,8,KNIFEPIC+gamestate.weapon);
	else if (gamestate.weapon == wp_newgun)
		StatusDrawPic (32,8,MACHINEGUNPIC);*/
	if (gamestate.armor <=0)
		gamestate.armor = 0;

	LatchNumber (34,16,3,gamestate.armor);
}


/*
==================
=
= DrawKeys
=
==================
*/

void DrawKeys (void)
{
	if (gamestate.keys & 1)
		StatusDrawPic (30,4,GOLDKEYPIC);
	else
		StatusDrawPic (30,4,NOKEYPIC);

	if (gamestate.keys & 2)
		StatusDrawPic (30,20,SILVERKEYPIC);
	else
		StatusDrawPic (30,20,NOKEYPIC);
}



/*
==================
=
= GiveWeapon
=
==================
*/

void GiveWeapon (int weapon)
{
	if (weapon == wp_pistol)
		GiveAmmo (4, 's');
	if (weapon == wp_machinegun)
		GiveAmmo (6, 'b');
	if (weapon == wp_chaingun)
		GiveAmmo (4, 'r');
	if (weapon == wp_newgun)
		GiveAmmo (8, 'b');
	if (weapon == wp_pgun)
		GiveAmmo (4, 'b');
	if (weapon == wp_blastgun)
		GiveAmmo (6, 'b');

	if (gamestate.bestweapon<weapon)
		gamestate.bestweapon = gamestate.weapon
		= gamestate.chosenweapon = weapon;

	DrawWeapon ();
}


//===========================================================================

/*
===============
=
= DrawAmmo
=
===============
*/

void	DrawAmmo (void)
{
	if (gamestate.weapon != wp_knife)
		LatchNumber (26,16,3,gamestate.ammo);
	else
	{
		StatusDrawPic (26,16,N_BLANKPIC);
		StatusDrawPic (27,16,N_BLANKPIC);
		StatusDrawPic (28,16,N_BLANKPIC);
	}
}


/*
===============
=
= GiveAmmo
=
===============
*/

void	GiveAmmo (int ammo, char s_o_b)
{
	if (!gamestate.ammo)				// knife was out
	{
		if (!gamestate.attackframe)
		{
			gamestate.weapon = gamestate.chosenweapon;
			DrawWeapon ();
		}
	}

	if(s_o_b == 'b')
	{
		gamestate.bullets += ammo;
	}
	if(s_o_b == 's')
	{
		gamestate.shells += ammo;
	}
	if(s_o_b == 'r')
	{
		gamestate.rockets += ammo;
	}

	//gamestate.ammo += ammo;
	if (gamestate.shells > 99)
		gamestate.shells = 99;
	if (gamestate.bullets > 250)
		gamestate.bullets = 250;
	if (gamestate.rockets > 25)
		gamestate.rockets = 25;

	if (gamestate.chosenweapon == wp_pistol)
	{
		gamestate.ammo = gamestate.shells;
	}
	if (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.weapon == wp_pgun || gamestate.weapon == wp_blastgun)
	{
		gamestate.ammo = gamestate.bullets;
	}
	if (gamestate.chosenweapon == wp_chaingun)
	{
		gamestate.ammo = gamestate.rockets;
	}

	DrawAmmo ();
}

//===========================================================================

/*
==================
=
= GiveKey
=
==================
*/

void GiveKey (int key)
{
	gamestate.keys |= (1<<key);
	DrawKeys ();
}



/*
=============================================================================

							MOVEMENT

=============================================================================
*/


/*
===================
=
= GetBonus
=
===================
*/
void GetBonus (statobj_t *check)
{
	switch (check->itemnumber)
	{
	case	bo_firstaid:
		if (gamestate.health >= 100)
			return;

		SD_PlaySound (HEALTH2SND);
		HealSelf (25);
		break;

	case	bo_key1:
	case	bo_key2:
	case	bo_key3:
	case	bo_key4:
		GiveKey (check->itemnumber - bo_key1);
		SD_PlaySound (GETKEYSND);
		break;

	case	bo_cross:
		SD_PlaySound (BONUS1SND);
		GivePoints (100);
		gamestate.treasurecount++;
		break;

	case	bo_chalice:
		SD_PlaySound (BONUS2SND);
		GivePoints (500);
		gamestate.treasurecount++;
		break;
	case	bo_bible:
		SD_PlaySound (BONUS3SND);
		GivePoints (1000);
		gamestate.treasurecount++;
		break;
	case	bo_crown:
		SD_PlaySound (BONUS4SND);
		GivePoints (5000);
		gamestate.treasurecount++;
		break;

	case	bo_clip:
		if (gamestate.bullets == 250)
			return;

		SD_PlaySound (GETAMMOSND);
		GiveAmmo (8, 'b');
		break;
	case	bo_clip2:
		if (gamestate.bullets == 250)
			return;

		SD_PlaySound (GETAMMOSND);
		GiveAmmo (4, 'b');
		break;

//#ifdef SPEAR
	case	bo_25clip:
		if (gamestate.bullets == 250)
		  return;

		SD_PlaySound (GETAMMOSND);
		GiveAmmo (25, 'b');
		break;
//#endif

	case	bo_machinegun:
		SD_PlaySound (GETMACHINESND);
		//if (gamestate.bestweapon < wp_machinegun)
		//{
			GiveWeapon (wp_machinegun);
		//}
		//else
		//if (mapon==9)
		//{
		//	gamestate.got2mguns = 1;
		//	GiveWeapon (wp_machinegun);
		//}
		break;
	case	bo_chaingun:
//		SD_PlaySound (GETGATLINGSND);
		GiveWeapon (wp_chaingun);
		SD_PlaySound (KEINSND);

		StatusDrawPic (17,4,GOTGATLINGPIC);
		facecount = 0;
		gotgatgun = 1;
		break;

	case	bo_fullheal:
		SD_PlaySound (BONUS1UPSND);
		HealSelf (50);
		GiveAmmo (50, 'b');
		GiveAmmo (25, 's');	//give shells too
		GiveAmmo (12, 'r');
		//GiveExtraMan ();
		GiveArmor (50);
		gamestate.treasurecount++;
		break;

	case	bo_food:
		if (gamestate.health >= 100)
			return;

		SD_PlaySound (HEALTH1SND);
		HealSelf (10);
		break;

	case	bo_alpo:
		if (gamestate.health == 115)
			return;

		SD_PlaySound (HEALTH1SND);
		HealSelf (1);
		break;

	case	bo_gibs:
		/*if (gamestate.health >10)
			return;

		SD_PlaySound (SLURPIESND);
		HealSelf (1);*/
		if (gamestate.shells == 99)
			return;

		SD_PlaySound (MEINSND);
		GiveAmmo (4, 's');
//		GiveWeapon (wp_pistol);
		break;

	case	bo_spear:
		spearflag = true;
		spearx = player->x;
		speary = player->y;
		spearangle = player->angle;
		playstate = ex_completed;
		break;

	case 	bo_25shell:
		if (gamestate.shells == 99)
			return;

		SD_PlaySound (MEINSND);
		GiveAmmo (16, 's');
		break;
	case	bo_rocket:
		if (gamestate.rockets == 25)
			return;

		SD_PlaySound (GETAMMOSND);
		GiveAmmo (2, 'r');
		break;
	case	bo_newgun:
		SD_PlaySound (GETGATLINGSND);
		GiveWeapon (wp_newgun);
		break;
	case	bo_pistols:
		SD_PlaySound (GETMACHINESND);
		GiveWeapon (wp_pgun);
		break;
	case	bo_light:
		if (gamestate.flash)
			StartBonusFlash ();
		return;

	}

	StartBonusFlash ();
	check->shapenum = -1;			// remove from list
}


/*
===================
=
= TryMove
=
= returns true if move ok
= debug: use pointers to optimize
===================
*/

boolean TryMove (objtype *ob)
{
	int			xl,yl,xh,yh,x,y;
	objtype		*check;
	long		deltax,deltay;

	xl = (ob->x-PLAYERSIZE) >>TILESHIFT;
	yl = (ob->y-PLAYERSIZE) >>TILESHIFT;

	xh = (ob->x+PLAYERSIZE) >>TILESHIFT;
	yh = (ob->y+PLAYERSIZE) >>TILESHIFT;

//
// check for solid walls
//
	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check && check<objlist)
				return false;
		}

//
// check for actors
//
	if (yl>0)
		yl--;
	if (yh<MAPSIZE-1)
		yh++;
	if (xl>0)
		xl--;
	if (xh<MAPSIZE-1)
		xh++;

	for (y=yl;y<=yh;y++)
		for (x=xl;x<=xh;x++)
		{
			check = actorat[x][y];
			if (check > objlist
			&& (check->flags & FL_SHOOTABLE) )
			{
				deltax = ob->x - check->x;
				if (deltax < -MINACTORDIST || deltax > MINACTORDIST)
					continue;
				deltay = ob->y - check->y;
				if (deltay < -MINACTORDIST || deltay > MINACTORDIST)
					continue;

				return false;
			}
		}

	return true;
}


/*
===================
=
= ClipMove
=
===================
*/

void ClipMove (objtype *ob, long xmove, long ymove)
{
	long	basex,basey;

	basex = ob->x;
	basey = ob->y;

	ob->x = basex+xmove;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	if (noclip && ob->x > 2*TILEGLOBAL && ob->y > 2*TILEGLOBAL &&
	ob->x < (((long)(mapwidth-1))<<TILESHIFT)
	&& ob->y < (((long)(mapheight-1))<<TILESHIFT) )
		return;		// walk through walls

//	if (!SD_SoundPlaying())
//		SD_PlaySound (HITWALLSND);

	ob->x = basex+xmove;
	ob->y = basey;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey+ymove;
	if (TryMove (ob))
		return;

	ob->x = basex;
	ob->y = basey;
}

//==========================================================================

/*
===================
=
= VictoryTile
=
===================
*/

void VictoryTile (void)
{
if (mapon == 8)
{
//#ifndef SPEAR
	SpawnBJVictory ();
//#endif

	gamestate.victoryflag = true;
}
else if (gamestate.episode == 4 && mapon == 4)
{
//#ifndef SPEAR
	SpawnBJVictory ();
//#endif

	gamestate.victoryflag = true;
}
else if (gamestate.episode == 1 && mapon == 7)
{
	playstate = ex_completed;
}
else if (gamestate.episode == 4 && mapon == 0)
{
	playstate = ex_completed;
}
else if (gamestate.episode == 2 && mapon == 1)
{
	playstate = ex_completed;
}
else
{
	playstate = ex_completed;
}

}


/*
===================
=
= Thrust
=
===================
*/

void Thrust (int angle, long speed)
{
	long xmove,ymove;
	long	slowmax;
	unsigned	offset;


	//
	// ZERO FUNNY COUNTER IF MOVED!
	//
	#ifdef SPEAR
	if (speed)
		funnyticount = 0;
	#endif

	thrustspeed += speed;
//
// moving bounds speed
//
	if (speed >= MINDIST*2)
		speed = MINDIST*2-1;

	xmove = FixedByFrac(speed,costable[angle]);
	ymove = -FixedByFrac(speed,sintable[angle]);

	ClipMove(player,xmove,ymove);

	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;

	offset = farmapylookup[player->tiley]+player->tilex;
	player->areanumber = *(mapsegs[0] + offset) -AREATILE;

	if (*(mapsegs[1] + offset) == EXITTILE)
		VictoryTile ();
}


/*
=============================================================================

								ACTIONS

=============================================================================
*/


/*
===============
=
= Cmd_Fire
=
===============
*/

void Cmd_Fire (void)
{
	if(!gamestate.shells && gamestate.bestweapon == wp_pistol)
	{
		gamestate.weapon = wp_knife;
		gamestate.chosenweapon = wp_knife;
	}
	if(!gamestate.bullets && (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun) && !gamestate.shells)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_knife;
	}
   ////////////////////////////narg
	if (!gamestate.bullets && (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun) && gamestate.shells)
	{
		gamestate.weapon = gamestate.chosenweapon = wp_pistol;
	}
   ////////////////////////////narg
	if(!gamestate.bullets && !gamestate.shells && !gamestate.rockets)
	{
		gamestate.weapon = wp_knife;
		gamestate.chosenweapon = wp_knife;
	}

	buttonheld[bt_attack] = true;

	gamestate.weaponframe = 0;

	player->state = &s_attack;

	gamestate.attackframe = 0;
	// attack count
	if (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun)
	{
		gamestate.attackcount =
			attackinfo[gamestate.weapon][gamestate.attackframe].tics;
	}
	else if (gamestate.chosenweapon == wp_newgun)
	{
		gamestate.attackcount =
		attackinfo[wp_machinegun][gamestate.attackframe].tics;
	}
	else if (gamestate.chosenweapon == wp_pgun)
	{
		gamestate.attackcount =
		attackinfo[wp_machinegun][gamestate.attackframe].tics;
	}
	else if (gamestate.chosenweapon == wp_blastgun)
	{
		gamestate.attackcount =
		attackinfo[wp_machinegun][gamestate.attackframe].tics;
	}
	// weapon frame
	if (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun)
	{
		gamestate.weaponframe =
			attackinfo[gamestate.weapon][gamestate.attackframe].frame;
	}
	else if (gamestate.chosenweapon == wp_newgun)
	{
		gamestate.weaponframe =
			attackinfo[wp_machinegun][gamestate.attackframe].frame;
	}
	else if (gamestate.chosenweapon == wp_pgun)
	{
		gamestate.weaponframe =
			attackinfo[wp_machinegun][gamestate.attackframe].frame;
	}
	else if (gamestate.chosenweapon == wp_blastgun)
	{
		gamestate.weaponframe =
			attackinfo[wp_machinegun][gamestate.attackframe].frame;
	}
}

//===========================================================================

/*
===============
=
= Cmd_Use
=
===============
*/

void Cmd_Use (void)
{
	objtype 	*check;
	int			checkx,checky,doornum,dir;
	boolean		elevatorok;


//
// find which cardinal direction the player is facing
//
	if (player->angle < ANGLES/8 || player->angle > 7*ANGLES/8)
	{
		checkx = player->tilex + 1;
		checky = player->tiley;
		dir = di_east;
		elevatorok = true;
	}
	else if (player->angle < 3*ANGLES/8)
	{
		checkx = player->tilex;
		checky = player->tiley-1;
		dir = di_north;
		elevatorok = false;
	}
	else if (player->angle < 5*ANGLES/8)
	{
		checkx = player->tilex - 1;
		checky = player->tiley;
		dir = di_west;
		elevatorok = true;
	}
	else
	{
		checkx = player->tilex;
		checky = player->tiley + 1;
		dir = di_south;
		elevatorok = false;
	}

	doornum = tilemap[checkx][checky];
	if (*(mapsegs[1]+farmapylookup[checky]+checkx) == PUSHABLETILE)
	{
	//
	// pushable wall
	//

		PushWall (checkx,checky,dir);
		return;
	}
	if (!buttonheld[bt_use] && doornum == ELEVATORTILE && elevatorok)
	{
	//
	// use elevator
	//
		buttonheld[bt_use] = true;

		tilemap[checkx][checky]++;		// flip switch
		if (*(mapsegs[0]+farmapylookup[player->tiley]+player->tilex) == ALTELEVATORTILE)
			playstate = ex_secretlevel;
		else
			playstate = ex_completed;
		SD_PlaySound (LEVELDONESND);
		SD_WaitSoundDone();
	}
	else if (!buttonheld[bt_use] && doornum & 0x80)
	{
		buttonheld[bt_use] = true;
		OperateDoor (doornum & ~0x80);
	}
	else
		SD_PlaySound (DONOTHINGSND);

}

/*
=============================================================================

						   PLAYER CONTROL

=============================================================================
*/



/*
===============
=
= SpawnPlayer
=
===============
*/

void SpawnPlayer (int tilex, int tiley, int dir)
{
	player->obclass = playerobj;
	player->active = true;
	player->tilex = tilex;
	player->tiley = tiley;
	player->areanumber =
		*(mapsegs[0] + farmapylookup[player->tiley]+player->tilex);
	player->x = ((long)tilex<<TILESHIFT)+TILEGLOBAL/2;
	player->y = ((long)tiley<<TILESHIFT)+TILEGLOBAL/2;
	player->state = &s_player;
	player->angle = (1-dir)*90;
	if (player->angle<0)
		player->angle += ANGLES;
	player->flags = FL_NEVERMARK;
	Thrust (0,0);				// set some variables

	InitAreas ();
}


//===========================================================================

/*
===============
=
= T_KnifeAttack
=
= Update player hands, and try to do damage when the proper frame is reached
=
===============
*/

void	KnifeAttack (objtype *ob)
{
	objtype *check,*closest;
	long	dist;

	if (gamestate.extraep)
	{
		SD_PlaySound (MEINGOTTSND);
	}
	else
	{
		SD_PlaySound (ATKKNIFESND);
	}

// actually fire
	dist = 0x7fffffff;
	closest = NULL;
	for (check=ob->next ; check ; check=check->next)
		if ( (check->flags & FL_SHOOTABLE)
		&& (check->flags & FL_VISABLE)
		&& abs (check->viewx-centerx) < shootdelta
		)
		{
			if (check->transx < dist)
			{
				dist = check->transx;
				closest = check;
			}
		}

/*
if ( (check->flags & FL_VISABLE) && abs (check->viewx-centerx) < shootdelta)
		{
			if (gamestate.trash == 0)
			{
				gamestate.trash = 1;
			}
			else if (gamestate.trash == 1)
			{
				gamestate.trash = 2;
			}
			else if (gamestate.trash == 2)
			{
				gamestate.trash = 3;
			}
		}*/

	if (!closest || dist> 0x18000l)
	{
	// missed
		gamestate.trash = 0;
		return;
	}

// hit something
	if (gamestate.extraep)
	{
		DamageActor (closest,US_RndT() >> 2);
		if (gamestate.trash == 0)
		{
			gamestate.trash = 1;
		}
		else if (gamestate.trash == 1)
		{
			gamestate.trash = 2;
		}
		else if (gamestate.trash == 2)
		{
			gamestate.trash = 0;
		}
		DrawPlayerWeapon ();
	}
	else
	{
		DamageActor (closest,US_RndT() >> 4);
	}
}



void	GunAttack (objtype *ob)
{

	objtype *check,*closest,*oldclosest;
	int		damage;
	int		dx,dy,dist;
	long	viewdist;

	if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)
	{
		gamestate.weapon = wp_knife;
	}


	switch (gamestate.weapon)
	{
	case wp_pistol:
		SD_PlaySound (ATKPISTOLSND);
		break;
	case wp_machinegun:
		SD_PlaySound (ATKMACHINEGUNSND);
		break;
	case wp_chaingun:
		SD_PlaySound (SLURPIESND);
		S_SRocket ();
		break;
	case wp_newgun:
		SD_PlaySound (ATKGATLINGSND);
		//SD_PlaySound (ATKMACHINEGUNSND);
		//gamestate.bullets--;
		if (gamestate.bullets <= 0)
			gamestate.bullets = 0;
		if (gamestate.ammo <= 0)
			gamestate.ammo = 0;
	gamestate.ammo = gamestate.bullets;
		break;
	case wp_pgun:
		SD_PlaySound (NAZIFIRESND);
		SD_PlaySound (NAZIFIRESND);
		gamestate.bullets--;
		if (gamestate.bullets <= 0)
			gamestate.bullets = 0;
		if (gamestate.ammo <= 0)
			gamestate.ammo = 0;

		break;
	case wp_blastgun:
		SD_PlaySound (ATKGATLINGSND);
		if (gamestate.bullets <= 0)
			gamestate.bullets = 0;
		if (gamestate.ammo <= 0)
			gamestate.ammo = 0;

		break;
	}

	madenoise = true;

//
// find potential targets
//
if (gamestate.chosenweapon != wp_chaingun)
{
	viewdist = 0x7fffffffl;
	closest = NULL;

	while (1)
	{
		oldclosest = closest;

		for (check=ob->next ; check ; check=check->next)
			if ( (check->flags & FL_SHOOTABLE)
			&& (check->flags & FL_VISABLE)
			&& abs (check->viewx-centerx) < shootdelta
			)
			{
				if (check->transx < viewdist)
				{
					viewdist = check->transx;
					closest = check;
				}
			}

		if (closest == oldclosest)
			return;						// no more targets, all missed

	//
	// trace a line from player to enemey
	//
		if (CheckLine(closest))
			break;

	}

//
// hit something
//
	dx = abs(closest->tilex - player->tilex);
	dy = abs(closest->tiley - player->tiley);
	dist = dx>dy ? dx:dy;

/*	if (dist<2)
		damage = US_RndT() / 4;
	else if (dist<4)
		damage = US_RndT() / 6;
	else
	{
		if ( (US_RndT() / 12) < dist)		// missed
			return;
		damage = US_RndT() / 6;
	}
*/
	switch (gamestate.weapon)
	{
		case wp_pistol:
				if (dist<2)
					damage = US_RndT();
				else if (dist<4)
					damage = US_RndT() / 2;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 2;
				}
				break;
		case wp_machinegun:
				if (dist<2)
					damage = US_RndT() / 5;
				else if (dist<4)
					damage = US_RndT() / 6;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 7;
				}
				break;
		case wp_newgun:
				if (dist<2)
					damage = US_RndT() / 3;
				else if (dist<4)
					damage = US_RndT() / 4;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 5;
				}
				break;

/*		case wp_chaingun:
				if (dist<2)
					damage = US_RndT() / 4;
				else if (dist<4)
					damage = US_RndT() / 6;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 6;
				}
				break;
*/
		case wp_pgun:
				if (dist<2)
					damage = US_RndT() / 4;
				else if (dist<4)
					damage = US_RndT() / 6;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 7;
				}
				break;
			case wp_blastgun:
				if (dist<2)
					damage = US_RndT() / 3;
				else if (dist<4)
					damage = US_RndT() / 4;
				else
				{
					if ( (US_RndT() / 12) < dist)		// missed
					return;
					damage = US_RndT() / 5;
				}
				break;

	}

	DamageActor (closest,damage);
}	//end of if statement


}	//end of function

//===========================================================================

/*
===============
=
= VictorySpin
=
===============
*/

void VictorySpin (void)
{
	long	desty;

	if (player->angle > 270)
	{
		player->angle -= tics * 3;
		if (player->angle < 270)
			player->angle = 270;
	}
	else if (player->angle < 270)
	{
		player->angle += tics * 3;
		if (player->angle > 270)
			player->angle = 270;
	}

	desty = (((long)player->tiley-5)<<TILESHIFT)-0x3000;

	if (player->y > desty)
	{
		player->y -= tics*4096;
		if (player->y < desty)
			player->y = desty;
	}
}


//===========================================================================

/*
===============
=
= T_Attack
=
===============
*/

void	T_Attack (objtype *ob)
{
	struct	atkinf	*cur;

	UpdateFace ();

	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}

	if ( buttonstate[bt_use] && !buttonheld[bt_use] )
		buttonstate[bt_use] = false;

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		buttonstate[bt_attack] = false;

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;

	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;


				//	added for new gun

			if (!gamestate.bullets && (gamestate.chosenweapon == wp_newgun  || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun) && !gamestate.shells  && !gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.bullets && (gamestate.chosenweapon == wp_newgun  || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun) && gamestate.shells)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.bullets && (gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun) && !gamestate.shells && gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			///////


//
// change frame and fire
//
	gamestate.attackcount -= tics;
	while (gamestate.attackcount <= 0)
	{
		/// it kept switching to mgun  (this didn't do anything 10/11/99)
		if (gamestate.bestweapon < wp_machinegun && gamestate.weapon == wp_machinegun && gamestate.shells)
			gamestate.weapon = gamestate.chosenweapon = wp_pistol;
		if (gamestate.bestweapon < wp_machinegun && gamestate.weapon == wp_machinegun && !gamestate.shells)
			gamestate.weapon = gamestate.chosenweapon = wp_knife;
		///


		if (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun)
			cur = &attackinfo[gamestate.weapon][gamestate.attackframe];
		else if (gamestate.chosenweapon == wp_newgun)
			cur = &attackinfo[wp_machinegun][gamestate.attackframe];
		else if (gamestate.chosenweapon == wp_pgun)
			cur = &attackinfo[wp_machinegun][gamestate.attackframe];
		else if (gamestate.chosenweapon == wp_blastgun)
			cur = &attackinfo[wp_machinegun][gamestate.attackframe];

		switch (cur->attack)
		{
		case -1:
			ob->state = &s_player;
			if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)
			{
				gamestate.weapon = wp_knife;
				DrawWeapon ();
			}
			else
			{
				if (gamestate.weapon != gamestate.chosenweapon)
				{
					gamestate.weapon = gamestate.chosenweapon;
					DrawWeapon ();
				}
			};



			// go to knife
			if (!gamestate.shells && gamestate.bestweapon == wp_pistol)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.bullets && !gamestate.shells && gamestate.bestweapon == wp_machinegun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}

			///test this

			if (!gamestate.shells && gamestate.bullets && gamestate.bestweapon >= wp_machinegun && (gamestate.chosenweapon != wp_chaingun || gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun))
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}

			///////

			//	added for new gun

			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && !gamestate.shells  && !gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && gamestate.shells)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && !gamestate.shells && gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			///////





			// no shells
			if (!gamestate.shells && gamestate.bullets && gamestate.chosenweapon == wp_pistol && gamestate.bestweapon >= wp_machinegun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}
			if (!gamestate.shells && !gamestate.bullets && gamestate.rockets && gamestate.bestweapon >= wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			// no bullets
			if (!gamestate.bullets && gamestate.shells && (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun))
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.bullets && !gamestate.shells && gamestate.rockets && gamestate.bestweapon >= wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			// no rockets
			if (!gamestate.rockets && gamestate.shells && gamestate.chosenweapon == wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.rockets && !gamestate.shells && gamestate.bullets && (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun))
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}

			//	added for new gun

			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && !gamestate.shells  && !gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && gamestate.shells)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.bullets && gamestate.chosenweapon == wp_newgun && !gamestate.shells && gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			///////


			gamestate.attackframe = gamestate.weaponframe = 0;
			return;

		case 4:
			if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)
				break;

			// go to knife
			if (!gamestate.shells && gamestate.bestweapon == wp_pistol)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.bullets && !gamestate.shells && gamestate.bestweapon == wp_machinegun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}
			if (!gamestate.shells && !gamestate.bullets && !gamestate.rockets)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_knife;
			}


			///test this

			if (!gamestate.shells && gamestate.bullets && gamestate.bestweapon >= wp_machinegun && gamestate.chosenweapon != wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}

			///////

			// no shells
			if (!gamestate.shells && gamestate.bullets && gamestate.chosenweapon == wp_pistol)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}
			if (!gamestate.shells && !gamestate.bullets && gamestate.rockets && gamestate.bestweapon >= wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			// no bullets
			if (!gamestate.bullets && gamestate.shells && (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon != wp_blastgun))
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.bullets && !gamestate.shells && gamestate.rockets && gamestate.bestweapon >= wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_chaingun;
				gamestate.ammo = gamestate.rockets;
			}
			// no rockets
			if (!gamestate.rockets && gamestate.shells && gamestate.chosenweapon == wp_chaingun)
			{
				gamestate.weapon = gamestate.chosenweapon = wp_pistol;
				gamestate.ammo = gamestate.shells;
			}
			if (!gamestate.rockets && !gamestate.shells && gamestate.bullets && (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun))
			{
				gamestate.weapon = gamestate.chosenweapon = wp_machinegun;
				gamestate.ammo = gamestate.bullets;
			}




			if (buttonstate[bt_attack])
				gamestate.attackframe -= 2;
		case 1:
			if (!gamestate.ammo)
			{	// can only happen with chain gun
				gamestate.attackframe++;
				break;
			}
			GunAttack (ob);

			//Decide wether to take away shells or bullets
			if (gamestate.chosenweapon == wp_pistol)
			{
				gamestate.shells--;
				gamestate.ammo = gamestate.shells;
			}
			if (gamestate.chosenweapon == wp_machinegun || gamestate.chosenweapon == wp_newgun || gamestate.chosenweapon == wp_pgun || gamestate.chosenweapon == wp_blastgun)
			{
				gamestate.bullets--;
				if (gamestate.bullets <= 0)
					gamestate.bullets = 0;
				if (gamestate.ammo <= 0)
					gamestate.ammo = 0;

				gamestate.ammo = gamestate.bullets;
			}
			if (gamestate.chosenweapon == wp_chaingun)
			{
				gamestate.rockets--;
				gamestate.ammo = gamestate.rockets;
			}

			DrawAmmo ();
			break;

		case 2:
			KnifeAttack (ob);
			break;

		case 3:
			if(gamestate.weapon != wp_knife)
			{
				if (gamestate.ammo && buttonstate[bt_attack])
					gamestate.attackframe -= 2;
				break;
			}
			if (gamestate.weapon == wp_knife && gamestate.extraep)
			{
				if (gamestate.ammo && buttonstate[bt_attack])
					gamestate.attackframe -= 2;
				break;
			}

		}

		gamestate.attackcount += cur->tics;
		gamestate.attackframe++;
//		gamestate.weaponframe =
//			attackinfo[gamestate.weapon][gamestate.attackframe].frame;
		if (gamestate.chosenweapon != wp_newgun && gamestate.chosenweapon != wp_pgun && gamestate.chosenweapon != wp_blastgun)
		{
			gamestate.weaponframe =
				attackinfo[gamestate.weapon][gamestate.attackframe].frame;
		}
		else if (gamestate.chosenweapon == wp_newgun)
		{
			gamestate.weaponframe =
				attackinfo[wp_machinegun][gamestate.attackframe].frame;
		}
		else if (gamestate.chosenweapon == wp_pgun)
		{
			gamestate.weaponframe =
				attackinfo[wp_machinegun][gamestate.attackframe].frame;
		}
		else if (gamestate.chosenweapon == wp_blastgun)
		{
			gamestate.weaponframe =
				attackinfo[wp_machinegun][gamestate.attackframe].frame;
		}

	}
      /*	if (gamestate.weapon == wp_newgun || gamestate.weapon == wp_machinegun)
	{
		if (gamestate.flash)
			StartBonusFlash ();
	}*/
}



//===========================================================================

/*
===============
=
= T_Player
=
===============
*/

void	T_Player (objtype *ob)
{
	if (gamestate.victoryflag)		// watching the BJ actor
	{
		VictorySpin ();
		return;
	}

	UpdateFace ();
	CheckWeaponChange ();

	if ( buttonstate[bt_use] )
		Cmd_Use ();

	if ( buttonstate[bt_attack] && !buttonheld[bt_attack])
		Cmd_Fire ();

//	if ( Keyboard[sc_X])
//		S_SRocket ();

	ControlMovement (ob);
	if (gamestate.victoryflag)		// watching the BJ actor
		return;


	plux = player->x >> UNSIGNEDSHIFT;			// scale to fit in unsigned
	pluy = player->y >> UNSIGNEDSHIFT;
	player->tilex = player->x >> TILESHIFT;		// scale to tile values
	player->tiley = player->y >> TILESHIFT;
}




/*
===============
=
= GiveArmor
=
===============
*/

void	GiveArmor (int points)
{
	gamestate.armor += points;
	if (gamestate.armor>100)
		gamestate.health = 100;

	DrawWeapon ();
	gotgatgun = 0;	// JR
	DrawFace ();
}
